require 'spec_helper'

describe 'forecast errors' do
  before { WebMock.disable_net_connect! }

  it "wraps errors" do
    stub_request(:get, /\/projects/).to_return({:status => ['400', 'Bad Request']}, {:body => "[]", :status => 200})
    expect { forecast.projects.all }.to raise_error(Forecast::BadRequest)

    stub_request(:get, /\/projects/).to_return({:status => ['404', 'Not Found']}, {:body => "[]", :status => 200})
    expect { forecast.projects.all }.to raise_error(Forecast::NotFound)

    stub_request(:get, /\/projects/).to_return({:status => ['500', 'Server Error']}, {:body => "[]", :status => 200})
    expect { forecast.projects.all }.to raise_error(Forecast::ServerError)

    stub_request(:get, /\/projects/).to_return({:status => ['502', 'Bad Gateway']}, {:body => "[]", :status => 200})
    expect { forecast.projects.all }.to raise_error(Forecast::Unavailable)

    stub_request(:get, /\/projects/).to_return({:status => ['503', 'Rate Limited']}, {:body => "[]", :status => 200})
    expect { forecast.projects.all }.to raise_error(Forecast::RateLimited)
  end
end
