require 'spec_helper'

describe 'forecast projects' do

  describe 'all' do
    it 'works' do
      cassette('projects-all') do
        projects = forecast.projects.all

        expect(projects.class).to be(Array)
        expect(projects.size > 1).to eq(true)
      end
    end
  end

  describe 'find' do
    it 'works' do
      cassette('projects-find') do
        projects = forecast.projects.all
        project_id = projects.first.id
        project = forecast.projects.find(project_id)

        expect(project.class).to be(Forecast::Project)
        expect(project.id > 1).to eq(true)
      end
    end
  end

  describe 'select_by_harvest_id()' do
    it 'works' do
      cassette('project-find_by_harvest_id') do
        project = forecast.projects.find_by_harvest_id(mm_harvest_project_id)

        expect(project.class).to be(Forecast::Project)
        expect(project.id > 1).to eq(true)
        expect(project.harvest_id).to eq(mm_harvest_project_id)
      end
    end
  end

end
