module ForecastedHelpers

  def mm_harvest_project_id
    11877152
  end

  def mm_forecast_project_id
    767184
  end


  def self.credentials
    unless File.exist?("#{File.dirname(__FILE__)}/forecast_credentials.yml")
      raise "You need a credentials file in support/forecast_credentials.yml!!"
    end
    @credentials ||= YAML.load_file("#{File.dirname(__FILE__)}/forecast_credentials.yml")
  end

  def self.simple_forecast
    Forecast.client({
      forecast_account_id: credentials["forecast_account_id"],
      access_token: credentials["access_token"]
    })
  end

  def credentials
    ForecastedHelpers.credentials
  end

  def forecast
    @forecast ||= ForecastedHelpers.simple_forecast
  end

  def hardy_forecast
    Forecast.hardy_client(
      forecast_account_id: credentials[:forecast_account_id],
      access_token: credentials[:access_token]
    )
  end

  def self.clean_remote
    return unless ENV['TRAVIS'].nil?

    forecast = simple_forecast

    # harvest = simple_harvest
    # forecast.users.all.each do |u|
    #   harvest.reports.expenses_by_user(u, Time.utc(2000, 1, 1), Time.utc(2014, 6, 21)).each do |expense|
    #     harvest.expenses.delete(expense, u)
    #   end

    #   harvest.reports.time_by_user(u, Time.utc(2000, 1, 1), Time.utc(2014, 6, 21)).each do |time|
    #     harvest.time.delete(time, u)
    #   end

    #   harvest.users.delete(u) if u.email != credentials["username"]
    # end

    # we store expenses on this date in the tests
    # harvest.expenses.all(Time.utc(2009, 12, 28)).each {|e| harvest.expenses.delete(e) }

    # %w(expense_categories time projects invoices contacts clients tasks).each do |collection|
    #   harvest.send(collection).all.each {|m| harvest.send(collection).delete(m) }
    # end
  end
end
